<?php
session_start();
require_once('tumblroauth.php');
require_once('config.php');
require_once('DB.php');

if (isset($_GET['f']) && function_exists($_GET['f'])) {
    $_GET['f']();
}

function logout() {
    unset($_SESSION['userId']);
    unset($_SESSION['username']);
    unset($_SESSION['useremail']);
    unset($_SESSION['access_token']);
    header("Location: ../index.php");
}

function clear_session() {
    unset($_SESSION['access_token']);
    unset($_SESSION['tumblrInfo']);
    header("Location: ../views/home.php");
}

function updateProfile() {
    if (isset($_SESSION) && isset($_SESSION['access_token'])) {
        $access_token = $_SESSION['access_token'];
        $connection = new TumblrOAuth(CONSUMER_KEY, CONSUMER_SECRET, $access_token['oauth_token'], $access_token['oauth_token_secret']);
        $info = $connection->get('user/info');
        if (isset($info['meta'])) {
            if ($info['meta']['msg'] == 'OK') {
                $username = $info['response']['user']['name'];
                $db     = DB::getInstance();
                $mysqli = $db->getConnection();
                $result = $mysqli->query("SELECT *  FROM dashboard WHERE username='".$username."'");
                if (mysqli_num_rows($result) <= 0) {
                    $fetchinterval 	= 100;
                    $postinterval  	= 100;
                    $notecount		= 100;
                    $exclude		= "N";
                    $posttype		= "";
                    $limit			= 50;
                    $stmt = $mysqli->prepare("INSERT INTO dashboard (oauth_token, oauth_token_secret, username, qlimit, fetchinterval, postinterval, notecount, posttype, postto, exclude) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                    $stmt->bind_param('sssddddsss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $username, $limit, $fetchinterval, $postinterval, $notecount, $posttype, $username, $exclude);
                    $stmt->execute();
                    $stmt->close();
                } else {
                    $at 	= $access_token['oauth_token'];
                    $ats 	= $access_token['oauth_token_secret'];
                    $result = $mysqli->query("UPDATE `dashboard` SET oauth_token = '$at', oauth_token_secret = '$ats' WHERE username = '$username'");
                }

                $followers  = $info['response']['user']['blogs'][0]['followers'];
                $followings = $info['response']['user']['following'];
                $likes      = $info['response']['user']['likes'];
                $userblog   = $info['response']['user']['name'];
                $blognames  = '';

                foreach($info['response']['user']['blogs'] as $index) {
                $blognames .= $index['name'] . ',';
                }

                $mysqli->query("UPDATE `user_info` SET oauth_token = '$at', oauth_token_secret = '$ats', blognames = '$blognames', followers = '$followers',
                followings = '$followings', likes = '$likes', userblog = '$userblog' WHERE id='".$_SESSION['userId']."' AND username='".$_SESSION['username']."'");
                
                $db_name = $_SESSION["username"] . "_posts";
                $mysqli->query('DROP TABLE IF EXISTS '.$db_name);
                $mysqli->query("CREATE TABLE IF NOT EXISTS $db_name (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY, oauth_token VARCHAR(100), oauth_token_secret VARCHAR(100), 
                            blogname VARCHAR(100), postid VARCHAR(50), reblog_key VARCHAR(50), type VARCHAR(10), notecount INT, state VARCHAR(15), title VARCHAR(100),
                            body longtext, caption TEXT, external_url TEXT, embed longtext, quote TEXT, source TEXT, url TEXT, thumbnail TEXT, description TEXT, author TEXT, excerpt TEXT, 
                            conversation longtext, link TEXT ) ENGINE=InnoDB");

                foreach ($info['response']['user']['blogs'] as $blog) {
                    $size = 0;
                    $link = 'https://api.tumblr.com/v2/blog/' . $blog['name'] . '.tumblr.com/posts?offset=' . $size . '&notes_info=true&reblog_info=true&api_key=' . CONSUMER_KEY;

                    $ch = curl_init($link);
                    curl_setopt($ch, CURLOPT_HEADER, 0);
                    curl_setopt($ch, CURLOPT_POST, 0);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                    $collection = json_decode(curl_exec($ch), true);
                    curl_close($ch);

                    if (isset($collection["meta"]) && ($collection["meta"]["msg"]=="OK")) {
                        foreach ($collection['response']['posts'] as $post) {
                            $notecount = isset($post['note_count']) ? intval($post['note_count']) : 0;
                            $blogType = $post['type'];
                    
                            switch ($blogType) {
                            case 'text':
                                $stmt      = $mysqli->prepare("INSERT INTO $db_name (oauth_token, oauth_token_secret, blogname, postid, reblog_key, type, notecount, title, body) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)");
                                $stmt->bind_param('ssssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $blog['name'], $post['id'], $post['reblog_key'], $blogType, $notecount, $post['title'], $post['body']);
                                break;
                    
                            case 'audio':
                                $stmt      = $mysqli->prepare("INSERT INTO $db_name (oauth_token, oauth_token_secret, blogname, postid, reblog_key, type, notecount, caption, external_url) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)");
                                $stmt->bind_param('ssssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $blog['name'], $post['id'], $post['reblog_key'], $blogType, $notecount, $post['caption'], $post['audio_source_url']);
                                break;
                    
                            case 'video':
                                $caption = "nothing";
                                $stmt      = $mysqli->prepare("INSERT INTO $db_name (oauth_token, oauth_token_secret, blogname, postid, reblog_key, type, notecount, caption, embed) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)");
                                $stmt->bind_param('ssssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $blog['name'], $post['id'], $post['reblog_key'], $blogType, $notecount, $caption, $post['player']['0']['embed_code']);
                                break;
                    
                            case 'quote':
                                $stmt      = $mysqli->prepare("INSERT INTO $db_name (oauth_token, oauth_token_secret, blogname, postid, reblog_key, type, notecount, quote, source) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)");
                                $stmt->bind_param('ssssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $blog['name'], $post['id'], $post['reblog_key'], $blogType, $notecount, $post['text'], $post['source']);
                                break;
                    
                            case 'link':
                                $stmt      = $mysqli->prepare("INSERT INTO $db_name (oauth_token, oauth_token_secret, blogname, postid, reblog_key, type, notecount, title, url, description, thumbnail, author, excerpt) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                                $stmt->bind_param('ssssssdssssss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $blog['name'], $post['id'], $post['reblog_key'], $blogType, $notecount, $post['title'], $post['url'], $post['description'], $post['photos']['0']['original_size']['url'], $post['author'], $post['excerpt']);
                                break;
                    
                            case 'chat':
                                $stmt      = $mysqli->prepare("INSERT INTO $db_name (oauth_token, oauth_token_secret, blogname, postid, reblog_key, type, notecount, title, conversation) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)");
                                $stmt->bind_param('ssssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $blog['name'], $post['id'], $post['reblog_key'], $blogType, $notecount, $post['title'], $post['body']);
                                break;
                    
                            case 'photo':
                                $stmt      = $mysqli->prepare("INSERT INTO $db_name (oauth_token, oauth_token_secret, blogname, postid, reblog_key, type, notecount, caption, source, link) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                                $stmt->bind_param('ssssssdsss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $blog['name'], $post['id'], $post['reblog_key'], $blogType, $notecount, $post['caption'], $post['photos']['0']['original_size']['url'], $post['image_permalink']);
                                break;
                    
                            case 'answer':
                                break;
                    
                            default:
                                break;
                            }
                            if ($blogType != 'answer') {
                            $stmt->execute();
                            $stmt->close();
                            }
                        }
                    }
                }

                header('Location: ../views/home.php');
            }
        }
    }
}
?>