(function($) {

  jQuery(window).load(function() {
    jQuery("#preloader").delay(100).fadeOut("slow");
    jQuery("#load").delay(100).fadeOut("slow");
  });

  //jQuery for page scrolling feature - requires jQuery Easing plugin
  $(function() {
    $("#since").datepicker();
    $("#until").datepicker();
    $('.page-scroll a').bind('click', function(event) {
      var $anchor = $(this);
      $('html, body').stop().animate({
        scrollTop: $($anchor.attr('href')).offset().top
      }, 1500, 'easeInOutExpo');
      event.preventDefault();
    });
  });
  $('#loading-image').hide();
  $('#loading-image1').hide();
  jQuery.fn.extend({
    disable: function(state) {
      return this.each(function() {
        this.disabled = state;
      });
    }
  });
  })(jQuery);

  jQuery(document).ready(function() {


  //show running queues
  $('#nav_queues').click(function() {
    $.ajax({
      type: 'post',
      url: 'managequeues.php',
      data: {
        username: $('#username').html()
      },
      success: function(response) {
        // We get the element having id of display_info and put the response inside it
        $('#queue_table').html(response);
      }
    });

  });
  $('#nav_dashboard').click(function() {
    $.ajax({
      type: 'post',
      url: 'dashboard.php',
      data: {
        username: $('#username').html()
      },
      success: function(response) {
        // We get the element having id of display_info and put the response inside it
        $('#dashboard').html(response);
      }
    });

  });
  //remove queue
  $("#queue_table").on("click", "span.table-remove", function() {
    if ($('#nav_queues').hasClass("active")) {
      if (confirm('Are you sure you want to remove this queue?')) {
        var $queuename = $(this).parents('tr').find('td:first');
        $(this).parents('tr').detach();
        $.ajax({
          type: 'post',
          url: 'managequeues.php',
          data: {
            queuename: $queuename.html()
          },
          success: function(response) {
            // We get the element having id of display_info and put the response inside it
            alert('Queue <' + $queuename.html() + "> removed successfully");
          }
        });
      }
    }
  });

  //clear queues
  $(".clearqueue").on("click", function() {
    if (confirm('Are you sure you want to remove all queues?')) {
      $.ajax({
        type: 'post',
        url: 'managequeues.php',
        data: {
          clear: "okay"
        },
        success: function(response) {
          // We get the element having id of display_info and put the response inside it
          alert("All queues removed");
        }
      });
    }
  });
    //run saved queues
  $('input[name=runsaved]').on("click", function() {
    if (confirm('Are you sure you want to run the queue?')) {
      $('#loading-image').show();
      var e = document.getElementById("queuelist");
      var queuename = e.options[e.selectedIndex].value;
      var formdata =[];
      $.ajax({
        type: 'post',
        url: 'managequeues.php',
        data: {
          saved: queuename
        },
        async: false,
        success: function(response) {
          // We get the element having id of display_info and put the response inside it
          formdata = jQuery.parseJSON(response);
        }
      });
      console.log(formdata);
      $.ajax({
        type: 'POST',
        url: 'action.php',
        data: formdata,
        dataType: 'json',
        encode: true,
        complete: function() {
          $('#loading-image').hide();
        },
        success: function(response) {
          // We get the element having id of display_info and put the response inside it
          alert(response);
        }
      });
    }
  });
  //save queue
  $('input[name=savequeue]').on("click", function() {
    var date = $('input[name=since]').val().split("/");
    var f = new Date(date[2], date[0] - 1, date[1]);
    var seconds = f.getTime() / 1000;
    if(($('input[name=queuename]').val() === "") || ($('input[name=blog]:checked').val() === undefined) || ($('input[name=qinterval]').val() === "") || ( $('input[name=since]').val() === "")|| ($('input[name=limit]').val() === "")){
      alert("Queue name or blog name or interval or since or limit is missng!");
      return;
    }
    
    var formData = {
      'save': "okay",
      'qname': $('input[name=queuename]').val(),
      'qinterval': $('input[name=qinterval]').val(),
      'uname': $('#username').html(),
      'blogname': $('input[name=blog]:checked').val(),
      'since': seconds
    };
    if ($('input[name=tag]').val() !== "")
      formData['tag'] = $('input[name=tag]').val();

    if ($('input[name=type]').val() !== "")
      formData['type'] = $('input[name=type]').val();

    if ($('input[name=notecount]').val() === "") {
      formData['notecount'] = 0;
    } else { 
      formData['notecount'] = $('input[name=notecount]').val(); 
    }

    if ($('input[name=limit]').val() !== "")
      formData['limit'] = $('input[name=limit]').val();

    if ($('input[name=repeat]').val() === "") {
      formData['repeat'] = 1;
    } else {
      formData['repeat'] = $('input[name=repeat]').val(); 
    }

    if ($('input[name=until]').val() !== "") {
      var dateuntil = $('input[name=until]').val().split("/");
      var ff = new Date(dateuntil[2], dateuntil[0] - 1, dateuntil[1]);
      var secondsuntil = ff.getTime() / 1000;
      formData['until'] = secondsuntil;
    }

    var fromblogs = [];
    for (var i = 1; i < blogcounter; i++) {
      if ($('input[name=input_blog' + i + ']').val() !== "")
        fromblogs.push($('input[name=input_blog' + i + ']').val());
    }

    if (typeof fromblogs !== 'undefined' && fromblogs.length > 0)
      formData['fromblogs'] = fromblogs;
    if(($('input[name=tag]').val() === "") && (fromblogs.length == 0)){
      alert("Input Tag or Blogs to fetch posts from!");
      return;
    }
    if (confirm('Are you sure you want to save this queue?')) {
      $.ajax({
        type: 'post',
        url: 'managequeues.php',
        data: formData,
        dataType: 'json', // what type of data do we expect back from the server
        encode: true,
        success: function(response) {
          // We get the element having id of display_info and put the response inside it
          alert(response);
        }
      });
    }
  });

  //Export posts
  $('input[name=tofile]').on("click", function() {
  $('#loading-image').show();
  var date = $('input[name=since]').val().split("/");
    var f = new Date(date[2], date[0] - 1, date[1]);
    var seconds = f.getTime() / 1000;
    if(($('input[name=queuename]').val() === "") || ($('input[name=blog]:checked').val() === undefined) || ($('input[name=qinterval]').val() === "") || ( $('input[name=since]').val() === "")|| ($('input[name=limit]').val() === "")){
      alert("Queue name or blog name or interval or since or limit is missng!");
      return;
    }

    var formData = {
      'queuename': $('input[name=queuename]').val(),
      'qinterval': $('input[name=qinterval]').val(),
      'username': $('#username').html(),
      'blogname': $('input[name=blog]:checked').val(),
      'since': seconds
    };
    if ($('input[name=tag]').val() !== "")
      formData['tag'] = $('input[name=tag]').val();

    if ($('input[name=type]').val() !== "")
      formData['type'] = $('input[name=type]').val();

    if ($('input[name=notecount]').val() === "") {
      formData['notecount'] = 0;
    } else { 
      formData['notecount'] = $('input[name=notecount]').val(); 
    }
    if ($('input[name=limit]').val() !== "")
      formData['limit'] = $('input[name=limit]').val();

    if ($('input[name=repeat]').val() === "") {
      formData['repeat'] = 1;
    } else { 
      formData['repeat'] = $('input[name=repeat]').val(); 
    }
    if ($('input[name=until]').val() !== "") {
      var dateuntil = $('input[name=until]').val().split("/");
      var ff = new Date(dateuntil[2], dateuntil[0] - 1, dateuntil[1]);
      var secondsuntil = ff.getTime() / 1000;
      formData['until'] = secondsuntil;
    }

    var fromblogs = [];
    for (var i = 1; i < blogcounter; i++) {
      if ($('input[name=input_blog' + i + ']').val() !== "")
        fromblogs.push($('input[name=input_blog' + i + ']').val());
    }

    if (typeof fromblogs !== 'undefined' && fromblogs.length > 0)
      formData['fromblogs'] = fromblogs;
    if(($('input[name=tag]').val() === "") && (fromblogs.length == 0)){
      alert("Input Tag or Blogs to fetch posts from!");
      return;
    }
  if (confirm('Are you sure you want to export this?')) {
    $.ajax({
      type: 'POST',
      url: 'exportqueue.php',
      data: formData,
      dataType: 'json', 
      encode: true,
      complete: function() {
          $('#loading-image1').hide();
      }
    })
    .done(function(response) {
      $('#loading-image').hide();
      let csvContent = "data:text/csv; charset=utf-8,";
      response.forEach(function(rowArray) {
        csvContent += rowArray + "\n";
      }); 
      var encodedUri = encodeURI(csvContent);
      var link = document.createElement("a");
      link.setAttribute("href", encodedUri);
      link.setAttribute("download", "Queue-" + new Date().getTime() + ".csv");
      document.body.appendChild(link);
      link.click();
      });
    }
  });
  //Track Blog
  $('input[name=track_btn]').on("click", function() {
    
  if(($('input[name=blog_to_track]').val() === "") || ($('input[name=tblog]:checked').val() === undefined) || ($('input[name=post_interval]').val() ==="")){
    alert("Fill the required fields please. ");
    return;
  }
  if($('#username').html() === ""){
    alert("Username not recognized");
    return;
  }
  var tblog = [];
  $.each($("input[name='tblog']:checked"), function(){
    tblog.push($(this).val());
  });
  var formData = {
    'sourceblog': $('input[name=blog_to_track]').val(),
    'postinterval': $('input[name=post_interval]').val(),
    'username': $('#username').html()
  };
  if (typeof tblog !== 'undefined' && tblog.length > 0)
    formData['destblogs'] = tblog;

  if ($('input[name=fetch_interval]').val() === "")
    formData['fetchinterval'] = 900;
  else
    formData['fetchinterval'] = $('input[name=fetch_interval]').val();

  if ($('input[name=track_tag]').val() !== "")
    formData['tag'] = $('input[name=track_tag]').val();

  if ($('input[name=track_type]').val() !== "")
    formData['type'] = $('input[name=track_type]').val();

  if ($('input[name=track_notecount]').val() !== "") 
    formData['notecount'] = $('input[name=track_notecount]').val();

  if (confirm('Are you sure you want to track this blog?')) {
    $('#loading-image').show();
    $.ajax({
      type: 'POST',
      url: 'trackblog.php',
      data: formData,
      dataType: 'json', 
      encode: true,
      complete: function() {
        $('#loading-image1').hide();
      }
    })
    .done(function(response) {
      alert(JSON.stringify(response,null,4));
      console.log(response);
    });
  }
  });
  //show running trackers
  $('#nav_trackers').click(function() {
    $.ajax({
      type: 'post',
      url: 'managetrackers.php',
      data: {
        username: $('#username').html()
      },
      success: function(response) {
        $('#tracker_table').html(response);
      }
    });
  });
  //update trackers
  $("#tracker_table").on("click", "span.table-save", function() {
    if (confirm('Are you sure you want to update this tracker?')) {
      var $id         = $(this).parents('tr').find('td:first');
      var $source     = $(this).parents('tr').find('td:nth-child(2)');
      var $f_nterval  = $(this).parents('tr').find('td:nth-child(4)');
      var $p_nterval  = $(this).parents('tr').find('td:nth-child(5)');
      var $tag        = $(this).parents('tr').find('td:nth-child(6)');
      var $type       = $(this).parents('tr').find('td:nth-child(7)');
      var $notecount  = $(this).parents('tr').find('td:nth-child(8)');
      $.ajax({
        type: 'post',
        url: 'managetrackers.php',
        data: {
          type:"update",
          id: $id.html(),
          sc: $source.html(),
          fi: $f_nterval.html(),
          pi: $p_nterval.html(),
          tg: $tag.html(),
          tp: $type.html(),
          nt: $notecount.html(),
        },
        success: function(response) {
          alert('Tracker <' + $id.html() + "> updated successfully");
        }
      });
    }
  });
  //remove tracker
  $("#tracker_table").on("click", "span.table-remove", function() {
    if (confirm('Are you sure you want to remove this tracker?')) {
      var $id         = $(this).parents('tr').find('td:first');
      var $source     = $(this).parents('tr').find('td:nth-child(2)');
      var $f_nterval  = $(this).parents('tr').find('td:nth-child(4)');
      var $p_nterval  = $(this).parents('tr').find('td:nth-child(5)');
      $(this).parents('tr').detach();
      $.ajax({
        type: 'post',
        url: 'managetrackers.php',
        data: {
          type:"remove",
          id: $id.html(),
          sc: $source.html(),
          fi: $f_nterval.html(),
          pi: $p_nterval.html()
        },
        success: function(response) {
          alert('Tracker  <' + $id.html() + "> removed successfully");
        }
      });
    }
  });
  //CSV import
  $('#csvform').on('submit', function(e){
    e.preventDefault();
    var upload_files = $('input[type=file]')[0].files;
    var data = new FormData();
    $.each(upload_files, function(key, value){
      data.append(key,value);
    });
    $.ajax({
      url: "csvimport.php",
      type: "POST",
      cache: false,
      data: data,
      processData: false,
      contentType: false,
      success: function (res) {
        alert(res);
      }
    });
    // $.ajax({
    //   url: 'csvimport.php',
    //   type: 'post',
    //   data: data,
    //   
    //   dataType: 'json',
    //   processData: false,
    //   contentType: false,
    //   success: function(res) {
    //     alert(res);
    //   }
    // });
  });
  //remove posts
  $("#post_table").on("click", "span.table-remove", function() {
    if ($('#nav_post').hasClass("active")) {
      if (confirm('Are you sure you want to remove this post?')) {
        var $postid = $(this).parents('tr').find('td:first');
        var queuename = $('#selectedqueue').val();
        $(this).parents('tr').detach();
        $.ajax({
          type: 'post',
          url: 'manageposts.php',
          data: {
            postid: $postid.html(),
            qname: queuename
          },
          success: function(response) {
            // We get the element having id of display_info and put the response inside it
            alert('Post  <' + $postid.html() + "> removed successfully");
          }
        });
      }
    }
  });

  //update post
  $("#post_table").on("click", "span.table-save", function() {
    if ($('#nav_post').hasClass("active")) {
      if (confirm('Are you sure you want to update this post?')) {
        var $id = $(this).parents('tr').find('td:first');
        var queuename = $('#selectedqueue').val();
        var qinfo = [];
        //    for (var i = 2; i < 6; i++) {
        var $info = $(this).parents('tr').find('td:nth-child(4)');
        qinfo.push($info.html());
        //      } 
        $.ajax({
          type: 'post',
          url: 'manageposts.php',
          data: {
            id: $id.html(),
            qinfo: qinfo,
            name: queuename
          },
          success: function(response) {
            // We get the element having id of display_info and put the response inside it
            alert('Post <' + $id.html() + "> updated successfully");
          }
        });
      }
    }
  });
  //update dashboard setting
  $("#dashboard").on("click", "span.table-save", function() {
    if ($('#nav_dashboard').hasClass("active")) {
      if (confirm('Are you sure you want to update this post?')) {
        var $uname = $(this).parents('tr').find('td:nth-child(1)');
        var $to = $(this).parents('tr').find('td:nth-child(2)');
        var $limit = $(this).parents('tr').find('td:nth-child(3)');
        var $post_interval = $(this).parents('tr').find('td:nth-child(4)');
        var $notecount= $(this).parents('tr').find('td:nth-child(5)');
        var $post_type = $(this).parents('tr').find('td:nth-child(6)');
        var $exclude = $(this).parents('tr').find('td:nth-child(7)');
        $.ajax({
          type: 'post',
          url: 'dashboard.php',
          data: {
            selected: $('#username').html(),
            uname : $uname.html(),
            to: $to.html(),
            limit:$limit.html(),
            post_interval: $post_interval.html(),
            notecount : $notecount.html(),
            post_type: $post_type.html(),
            exclude:$exclude.html()
          },
          success: function(response) {
            alert("Dashboard updated successfully");
          }
        });
      }
    }
  });
  //update queue
  $("#queue_table").on("click", "span.table-save", function() {
    var queueinfo =[];
    for (var i = 1; i < 5; i++) {
      var $info = $(this).parents('tr').find('td:nth-child(' + i + ')');
      queueinfo.push($info.html());
    }
    $.ajax({
        type: 'post',
        url: 'managequeues.php',
        data: {
          queueinfo: queueinfo
        },
        success: function(response) {
          // We get the element having id of display_info and put the response inside it
          alert('Queue <' + queueinfo[0] + "> updated successfully");
        }
    });
  });
  //see upcoming posts
  $("#queue_table").on("click", "span.table-see", function() {
    var $info = $(this).parents('tr').find('td:first');
    $('#nav_queues').removeClass('active');
    $('#nav_post').addClass('active');
    $('#selectedqueue').val($info.html());
    $.ajax({
      type: 'post',
      url: 'manageposts.php',
      data: {
        queuename: $info.html()
      },
      success: function(response) {
        // We get the element having id of display_info and put the response inside it
        $('#post_table').html(response);
      }
    });
    $("body, html").animate({
      scrollTop: $($(this).attr('href')).offset().top
    }, 600);
  });

  //start dashboard
  $("#startdashboard").on("click", function() {
    if (confirm('Are you sure you want to start the dashboard queue?')) {
      $("#stopdashboard").disable(false);
      $(this).disable(true);
      $.ajax({
        type: 'post',
        url: 'dashboard.php',
        data: {
          start: "okay"
        },
        success: function(response) {
          // We get the element having id of display_info and put the response inside it
          alert("dashboard started");
          $("#res").html(response);
        }
      });
    }
  });   
    
  //stop dashboard
  $("#stopdashboard").on("click", function() {
    if (confirm('Are you sure you want to stop the dashboard queue?')) {
      $("#startdashboard").disable(false);
      $(this).disable(true);
      $.ajax({
        type: 'post',
        url: 'dashboard.php',
        data: {
          stop: "okay"
        },
        success: function(response) {
          // We get the element having id of display_info and put the response inside it
          alert("dashboard stopped");
        }
      });
    }
  }); 

  $('.f1').each(function() {
    $('.f1 input[type="text"], .f1 input[type="password"], .f1 textarea').on('focus', function() {
      $(this).removeClass('input-error');
    });
  });

  $('#nav_post').on('mouseleave', function(e) {
    $(this).removeClass('active');
  });
  $("#form1").keypress(function(e) {
    if (e.which == 13) {
      var $targ = $(e.target);
      if (!$targ.is("textarea") && !$targ.is(":button,:submit")) {
        var focusNext = false;
        $(this).find(":input").each(function() {
          if (this === e.target) {
            focusNext = true;
          } else if (focusNext) {
            $(this).focus();
            return false;
          }
        });
        return false;
      }
    }
  });

  //add post input tag dynamically
  var postcounter = 2;
  var postlimit = 20;

  $('.addMoreposts').on('click', function(e) {
    if (postcounter == postlimit) {
      alert("You have reached the limit of adding " + postcounter + " inputs");
    } else {
      var newinput = document.createElement('input');
      newinput.type = 'text';
      newinput.name = 'input_post' + (postcounter);
      newinput.className = "col-md-8 col-md-offset-2";
      newinput.id = 'input_post' + (postcounter);
      document.getElementById("postlist").appendChild(newinput);
      ++postcounter;
    }
  });

  var blogcounter = 2;
  var bloglimit = 20;
  $('.addMoreblogs').on('click', function(e) {
    if(blogcounter == bloglimit) {
      alert("You have reached the limit of adding " + blogcounter + " inputs");
    } else {
      var newinput = document.createElement('input');
      newinput.type = 'text';
      newinput.name = 'input_blog' + (blogcounter);
      newinput.className = "input_blog";
      newinput.id = 'input_blog' + (blogcounter);
      document.getElementById("bloglist").appendChild(newinput);
      ++blogcounter;
    }
  });

  $('#form2').submit(function(event) {
    $('#loading-image1').show();
    var formData = {
      'queuename': $('input[name=squeuename]').val(),
      'qinterval': $('input[name=qsinterval]').val(),
      'username': $('#username').html(),
      'blogname': $('input[name=sblog]:checked').val()
    };

    if ($('input[name=srepeat]').val() === "") {
      formData['srepeat'] = 1;
    } else { 
      formData['srepeat'] = $('input[name=srepeat]').val(); 
    }

    var posts = [];
    for (var i = 1; i < postcounter; i++) {
      if ($('input[name=input_post' + i + ']').val() !== "")
        posts.push($('input[name=input_post' + i + ']').val());
    }

    if (typeof posts !== 'undefined' && posts.length > 0)
      formData['singleposts'] = posts;

    // process the form
    $.ajax({
      type: 'POST', // define the type of HTTP verb we want to use (POST for our form)
      url: 'singleaction.php', // the url where we want to POST
      data: formData, // our data object
      dataType: 'json', // what type of data do we expect back from the server
      encode: true,
      complete: function() {
        $('#loading-image1').hide();
      }
    })
    // using the done promise callback
    .done(function(data) {
      // log data to the console so we can see
      console.log(data);
      if (data['success']) {
        alert("done");
      }
    });
    event.preventDefault(); // if you want to disable the action
    return false;
  });

  $('.f1').on('submit', function(e) {
    $('#loading-image').show();

    var date = $('input[name=since]').val().split("/");
    var f = new Date(date[2], date[0] - 1, date[1]);
    var seconds = f.getTime() / 1000;

    var formData = {
      'queuename': $('input[name=queuename]').val(),
      'qinterval': $('input[name=qinterval]').val(),
      'username': $('#username').html(),
      'blogname': $('input[name=blog]:checked').val(),
      'since': seconds
    };
    if ($('input[name=tag]').val() !== "")
      formData['tag'] = $('input[name=tag]').val();

    if ($('input[name=type]').val() !== "")
      formData['type'] = $('input[name=type]').val();

    if ($('input[name=notecount]').val() === "") {
      formData['notecount'] = 0;
    } else { 
      formData['notecount'] = $('input[name=notecount]').val(); 
    }

    if ($('input[name=limit]').val() !== "")
      formData['limit'] = $('input[name=limit]').val();

    if ($('input[name=repeat]').val() === "") {
      formData['repeat'] = 1;
    } else { 
      formData['repeat'] = $('input[name=repeat]').val(); 
    }

    if ($('input[name=until]').val() !== "") {
      var dateuntil = $('input[name=until]').val().split("/");
      var ff = new Date(dateuntil[2], dateuntil[0] - 1, dateuntil[1]);
      var secondsuntil = ff.getTime() / 1000;
      formData['until'] = secondsuntil;
    }

    var fromblogs = [];
    for (var i = 1; i < blogcounter; i++) {
      if ($('input[name=input_blog' + i + ']').val() !== "")
        fromblogs.push($('input[name=input_blog' + i + ']').val());
    }

    if (typeof fromblogs !== 'undefined' && fromblogs.length > 0)
        formData['fromblogs'] = fromblogs;
    // process the form
    $.ajax({
      type: 'POST', // define the type of HTTP verb we want to use (POST for our form)
      url: 'action.php', // the url where we want to POST
      data: formData, // our data object
      dataType: 'json', // what type of data do we expect back from the server
      encode: true,
      complete: function() {
        $('#loading-image').hide();
      }
    })
    // using the done promise callback
    .done(function(data) {
      // log data to the console so we can see
      console.log(data);
      if (data['success']) {
        $('.result').html(data['count'] + " posts queued to <" + $('input[name=queuename]').val() + "> with tag " + $('input[name=tag]').val());
      }
    });
    // stop the form from submitting the normal way and refreshing the page
    e.preventDefault();
  });
});