<?php
session_start();
require_once('../inc/tumblroauth.php');
require_once('../inc/config.php');
require_once('../inc/process_class.php');
require_once('../inc/ChromePhp.php');
require_once('../inc/DB.php');
/* If access tokens are not available redirect to connect page. */
if (empty($_SESSION['access_token']) || empty($_SESSION['access_token']['oauth_token']) || empty($_SESSION['access_token']['oauth_token_secret'])) {
  header('Location: ../inc/redirect.php');
}

$db     = DB::getInstance();
$mysqli = $db->getConnection();

if (mysqli_connect_errno()) {
  printf("Connect failed: %s\n", mysqli_connect_error());
  exit();
}

ChromePhp::log('Started');
ChromePhp::log('DB Connect');

$errors = "";
$data   = array();
$result = array();

$access_token   = $_SESSION['access_token'];

$post_notecount = intval($_POST['notecount']);
$post_interval  = intval($_POST['qinterval']);
$post_repeat    = intval($_POST['repeat']);
$queue_status   = "active";
$blogname       = $_POST['blogname'];

$queuename      = str_replace(" ", "", $_POST['queuename']);
$queuename      = str_replace("-", "", $queuename);

$addingTag      = isset($_POST['addingTag']) ? $_POST['addingTag'] : '';

if ( isset($_SESSION['userblog']) && $_SESSION['userblog'] !== '')
  $username     = $_SESSION['userblog'];
else
  $username     = "";

if (isset($_POST['limit']))
  $limit     = intval($_POST['limit']);

if (isset($_POST['fromBlogs']) && $_POST['fromBlogs'] != "") {
  ChromePhp::log('With Bloged API');
  $post_fromblogs = $_POST['fromBlogs'];
  $size = 0;
  $requestlink="";

  while(true) {
    if ( isset($_POST['tag']) ) {
      $requestlink = 'https://api.tumblr.com/v2/blog/' . $post_fromblogs . '.tumblr.com/posts?tag=' . $_POST['tag'] . '&offset=' . $size . '&notes_info=true&reblog_info=true&api_key=' . CONSUMER_KEY;
    } else {
      $requestlink = 'https://api.tumblr.com/v2/blog/' . $post_fromblogs . '.tumblr.com/posts?offset=' . $size . '&notes_info=true&reblog_info=true&api_key=' . CONSUMER_KEY;
    }

    $ch = curl_init($requestlink);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_POST, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $collection = json_decode(curl_exec($ch), true);
    curl_close($ch);
    
    if ( isset($collection['meta']) && ($collection['meta']['msg'] == 'OK') ) {
      if ( $collection['response']['total_posts'] == 0 || sizeof($collection['response']['posts']) < 20) {
        $errors = "Not existed";
        break;
      }

      $size += sizeof($collection['response']['posts']);

      foreach ( $collection['response']['posts'] as $single ) {
        if ( isset($_POST['type']) && ($single['type'] !== $_POST['type']) ) {
          continue;
        }

        if ( isset($_POST['until']) ) {
          if ($single['timestamp'] > $_POST['until']) {
            continue;
          }
        }

        if ( (sizeof($result) >= $limit) && ($limit > 0 )) {
          ChromePhp::log('breaked at limit'.sizeof($result)."--".$limit);
          break 2;
        }

        if ( ($single['timestamp'] < $_POST['since']) ) {
          ChromePhp::log($single['timestamp'].'breaked at since');
          break 2;
        }

        if ( $single['note_count'] >= $_POST['notecount'] ) {
          array_push($result, $single);
        }
      }
    } else {
      $errors = $collection['meta']['msg'];
      break;
    }     
  }
  ChromePhp::log('total'. $size . ' Posts Fetched');

} else {
  ChromePhp::log('With Tagged API');
  $post_fromblogs = "";
  $lasttime = 0;

  if (isset($_POST['tag'])) {
    $requestlink = 'https://api.tumblr.com/v2/tagged?tag=' . $_POST['tag'] . '&api_key=' . CONSUMER_KEY;
    $ch     = curl_init($requestlink);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_POST, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $collection = json_decode(curl_exec($ch), true);
    curl_close($ch);

    if (isset($collection['meta']) && ($collection['meta']['msg'] == 'OK')) {
      foreach ($collection['response'] as $single) {
        if (isset($_POST['type']) && ($single['type'] !== $_POST['type'])) {               
          continue;
        }
        if (isset($_POST['until'])) {
          if ($single['timestamp'] > $_POST['until']) 
            continue;
        }
        if ((sizeof($result) >= $limit) && ($limit > 0)) {
          ChromePhp::log('breaked at limit'.sizeof($result)."--".$limit);
          break;
        }   
        if (($single['timestamp'] < $_POST['since'])) {
          ChromePhp::log($single['timestamp'].'breaked at since');
          break;
        } 
        if ($single['note_count'] >= $_POST['notecount']) {
          array_push($result, $single);
        }
      }
      
      $lasttime = $collection['response'][sizeof($collection['response']) - 1]['timestamp'];
    } else {
      $errors = $collection['meta']['msg'];
    }

    if ($lasttime != 0) {
      ChromePhp::log('Before Tagged While');
      while (true) {
        if (sizeof($collection['response']) < 20){
          $errors = "Not existed";
          break;
        }
        // ChromePhp::log('In tagged While');
        $stragain = 'https://api.tumblr.com/v2/tagged?tag=' . $_POST['tag'] . '&before=' . $lasttime . '&api_key=' . CONSUMER_KEY;
        $ch       = curl_init($stragain);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_POST, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $collection = json_decode(curl_exec($ch), true);
        curl_close($ch);

        if (isset($collection['meta']) && ($collection['meta']['msg'] == 'OK')) {
          if (sizeof($collection['response']) == 0) {
            break;
          }
          
          $lasttime = $collection['response'][sizeof($collection['response']) - 1]['timestamp'];
          foreach ($collection['response'] as $single) {
            if (isset($_POST['type']) && ($single['type'] !== $_POST['type'])) {                  
              continue;
            }
            if (isset($_POST['until'])){
              if ($single['timestamp'] > $_POST['until']) {
                continue;               
              }
            }
            if ((sizeof($result) >= $limit) && ($limit > 0)){
              ChromePhp::log('breaked at limit'.sizeof($result)."--".$limit);
              break 2;
            }  
            if (($single['timestamp'] < $_POST['since'])) {
              ChromePhp::log($single['timestamp'].'breaked at since');
              break 2;
            }
            if ($single['note_count'] >= $_POST['notecount']) {
              array_push($result, $single);
            }
          }
          if (sizeof($collection['response']) < 20) {
            $errors = "Not existed";
            break;
          }
        } else {
          $errors = $collection['meta']['msg'];
        }
      }
    } else {
      $errors = "Not existed";
    }
  } else {
    $errors = "Failed. Note: you should input either blog name or tag name.";
  }
}

function saveposts_todb($arr, $qname) {
  ChromePhp::log('Save to DB');
  $access_token  = $_SESSION['access_token'];
  $db     = DB::getInstance();
  $mysqli = $db->getConnection();
  $post_interval = intval($_POST['qinterval']);
  $blogname      = $_POST['blogname'];
  if (mysqli_connect_errno()) {
    printf("Connect failed: %s\n", mysqli_connect_error());
    exit();
  }
  if (isset($arr)) {
    foreach ($arr as $post) {
      $notecount = isset($post['note_count']) ? intval($post['note_count']) : 0;
      $blogType = $post['type'];

      switch ($blogType) {
        case 'text':
          $stmt      = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret, post_interval, blogname, postid, reblog_key, type, notecount, title, body) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
          $stmt->bind_param('ssdssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $post_interval, $blogname, $post['id'], $post['reblog_key'], $blogType, $notecount, $post['title'], $post['body']);
          break;

        case 'audio':
          $stmt      = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret, post_interval, blogname, postid, reblog_key, type, notecount, caption, external_url) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
          $stmt->bind_param('ssdssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $post_interval, $blogname, $post['id'], $post['reblog_key'], $blogType, $notecount, $post['caption'], $post['audio_source_url']);
          break;

        case 'video':
          $caption = "nothing";
          $stmt      = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret, post_interval, blogname, postid, reblog_key, type, notecount, caption, embed) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
          $stmt->bind_param('ssdssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $post_interval, $blogname, $post['id'], $post['reblog_key'], $blogType, $notecount, $caption, $post['player']['0']['embed_code']);
          break;

        case 'quote':
          $stmt      = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret, post_interval, blogname, postid, reblog_key, type, notecount, quote, source) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
          $stmt->bind_param('ssdssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $post_interval, $blogname, $post['id'], $post['reblog_key'], $blogType, $notecount, $post['text'], $post['source']);
          break;

        case 'link':
          $stmt      = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret, post_interval, blogname, postid, reblog_key, type, notecount, title, url, description, thumbnail, author, excerpt) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
          $stmt->bind_param('ssdssssdssssss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $post_interval, $blogname, $post['id'], $post['reblog_key'], $blogType, $notecount, $post['title'], $post['url'], $post['description'], $post['photos']['0']['original_size']['url'], $post['author'], $post['excerpt']);
          break;

        case 'chat':
          $stmt      = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret, post_interval, blogname, postid, reblog_key, type, notecount, title, conversation) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
          $stmt->bind_param('ssdssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $post_interval, $blogname, $post['id'], $post['reblog_key'], $blogType, $notecount, $post['title'], $post['body']);
          break;

        case 'photo':
          $stmt      = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret, post_interval, blogname, postid, reblog_key, type, notecount, caption, source, link) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
          $stmt->bind_param('ssdssssdsss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $post_interval, $blogname, $post['id'], $post['reblog_key'], $blogType, $notecount, $post['caption'], $post['photos']['0']['original_size']['url'], $post['image_permalink']);
          break;

        case 'answer':
          break;

        default:
          break;
      }
      if ($blogType != 'answer') {
        $stmt->execute();
        $stmt->close();
      }
    }
  }
  mysqli_close($mysqli);
}

if ( !empty($result) ) {
  if (!$mysqli->query("SELECT 1 FROM $queuename LIMIT 1")) {
    $mysqli->query("CREATE TABLE IF NOT EXISTS $queuename (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY,oauth_token VARCHAR(100),oauth_token_secret VARCHAR(100),post_interval INT, blogname VARCHAR(100),postid VARCHAR(50),reblog_key VARCHAR(50),type VARCHAR(10),notecount INT,state VARCHAR(15),title VARCHAR(100),body longtext,caption TEXT, external_url TEXT, embed longtext,quote TEXT,source TEXT,url TEXT, thumbnail TEXT, description TEXT, author TEXT, excerpt TEXT, conversation longtext,link TEXT ) ENGINE=InnoDB");
    $tag = isset($_POST['tag']) ? $_POST['tag'] : "";
    $posts_since = $_POST['since'];

    $stmt = $mysqli->prepare("INSERT INTO queues (queuename, username, toblog, fromblog, queued_tag, notecount, posts_since, queue_interval, status, adding_tag) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
    $stmt->bind_param('sssssdsdss', $queuename, $username, $blogname, $post_fromblogs, $tag, $post_notecount, $posts_since, $post_interval, $queue_status, $addingTag);
    $stmt->execute();
    $stmt->close();
  }

  shuffle($result);
  for ($i = 1; $i <= $post_repeat; $i++) {
    saveposts_todb($result, $queuename);
  }
  $size = sizeof($result);

  ChromePhp::log('Result size ' . $size);
  ChromePhp::log('SQL closed');
  
  $cmd     = '/opt/cpanel/ea-php56/root/usr/bin/php process.php ' . $queuename;

  ChromePhp::log($cmd);
  $process = new Process($cmd);
  $process->start();
  if ($process->status()) {
    ChromePhp::log("The process is currently running");
  } else {
    ChromePhp::log("The process is not running.");
    $errors = "Sorry, there are not available memory. Please delete inapposite queues and try again.";
  }

} else {
  if ($errors === "")
    $errors = "There is no proper post for the filters";
}

if ($errors === "") {
    $data['success']    = true;
    $data['message']    = 'Success!';
} else {
    $data['success'] = false;
    $data['errors']  = $errors;
}

echo json_encode($data); exit;

?>