<?php
session_start();
require_once('../inc/tumblroauth.php');
require_once('../inc/config.php');
require_once('../inc/process_class.php');
require_once('../inc/ChromePhp.php');
require_once('../inc/DB.php');
/* If access tokens are not available redirect to connect page. */
if (empty($_SESSION['access_token']) || empty($_SESSION['access_token']['oauth_token']) || empty($_SESSION['access_token']['oauth_token_secret'])) {
  header('Location: ../inc/redirect.php');
}

$db     = DB::getInstance();
$mysqli = $db->getConnection();

if (mysqli_connect_errno()) {
  printf("Connect failed: %s\n", mysqli_connect_error());
  exit();
}

ChromePhp::log('Started');
ChromePhp::log('DB Connect');

$errors = "";
$data   = array();
$result = array();

$access_token   = $_SESSION['access_token'];

$post_notecount = intval($_POST['notecount']);
$post_interval  = intval($_POST['qinterval']);
$post_repeat    = intval($_POST['repeat']);
$blogname       = $_POST['blogname'];

$queuename      = str_replace(" ", "", $_POST['queuename']);
$queuename      = str_replace("-", "", $queuename);
$post_fromblogs = $post_fromblogs = $_POST['fromBlogs'];
$post_tag       = isset($_POST['tag']) ? $_POST['tag'] : "";
$post_type      = isset($_POST['type']) ? $_POST['type'] : "";
$post_since     = $_POST['since'];
$post_until     = isset($_POST['until']) ? $_POST['until'] : "";
$post_limit     = isset($_POST['limit']) ? intval($_POST['limit']) : 20;

if ( isset($_SESSION['userblog']) && $_SESSION['userblog'] !== '')
  $username     = $_SESSION['userblog'];
else
  $username     = "";

$mysqli->query("CREATE TABLE IF NOT EXISTS `saved_queue` (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY, queuename VARCHAR(100), username VARCHAR(100), fromblog VARCHAR(100), toblog VARCHAR(100), queue_interval INT, queued_tag VARCHAR(100), queued_type VARCHAR(20), notecount INT, posts_since VARCHAR(100), posts_until VARCHAR(100), post_limit INT, post_repeat INT) ENGINE=InnoDB");

$stmt = $mysqli->prepare("INSERT INTO saved_queue (queuename, username, fromblog, toblog, queue_interval, queued_tag, queued_type, notecount, posts_since, posts_until, post_limit, post_repeat) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
$stmt->bind_param('ssssdssdssdd', $queuename, $username, $post_fromblogs, $blogname, $post_interval, $post_tag, $post_type, $post_notecount, $post_since, $post_until, $post_limit, $post_repeat);
$stmt->execute();
$stmt->close();
$data = array();
$data['success']    = true;
$data['message']    = 'Queue saved successfully!';
echo json_encode($data);
exit;

?>